#include "StdAfx.h"
#include "NSlider.h"
#include "RootContainer.h"

#include "ScriptletConstant.h"

REGISTER_COMPONENT_CREATOR(SCRIPTLET_SLIDER_NODE, CNSlider);
//////////////////////////////////////////////////////////////////////////

static const TCHAR NSLIDER_THUMB_NAME[] = _T("NSLIDER_THUMB_NAME");
const INT64 CNSlider::NSLIDER_POS_INVALID = -1;

IMPLEMENT_RTTI(CNSlider, CNPanel)

CNSlider::CNSlider(eDirection eDir /* = E_SLIDER_DIRECTION_HORZ */)
{
	m_eDirection = eDir;

	/** {kr} @n
	m_nPos = NSLIDER_POS_INVALID; @n
	׹ȣ : MMANGERSUS-69 @n
	 : 2008/07/05 @n
	۾ : hhd2002 @n
	 :  @n
		 ڸ . @n
	 : @n
		1. BTS Ư mov  ε @n
		2. Ʈ  ߰ ̵ @n
		3. Ŭ @n
		4. ̸ Ŭ @n
		5. ڵ  . @n
	ذ : @n
		CNSlider::SetPosValue Ҷ ó° 0϶ @n
		pos  0 Ϸ ϸ  ȵ. @n
		׷ ʱⰪ -1  ȿ  Ͽ @n
		ʱ⿡ 0  Է ϵ . @n
	{/kr} */
	m_nMin = 0;
	m_nMax = 100;
	m_nPos = NSLIDER_POS_INVALID;

	m_nKeyHop = 0;

	m_bPressed = FALSE;
	m_nKeyPressedTimePeriod = 0;

	m_Panel_Thumb.SetName(NSLIDER_THUMB_NAME);
}
CNSlider::~CNSlider()
{
}
void CNSlider::OnCreate()
{
	this->Add(&m_Panel_Thumb);

	m_pMouseListner_Slider_Thumb.Attach(new CMouseListener_Slider_Thumb(this, &m_Panel_Thumb));
	m_Panel_Thumb.AddMouseListener(m_pMouseListner_Slider_Thumb);

	m_pMouseListner_Slider.Attach(new CMouseListener_Slider(this, m_pMouseListner_Slider_Thumb.m_p));
	this->AddMouseListener(m_pMouseListner_Slider);

	m_pKeyListener_Slider.Attach(new CKeyListener_Slider(this));
	m_Panel_Thumb.AddKeyListener(m_pKeyListener_Slider.m_p);

	m_Panel_Thumb.MoveWindow(&m_rcThumbStart, TRUE);

	this->SetLayoutManager(this);

	m_StatePanelThumb.AttachControl(&m_Panel_Thumb);
	m_StatePanelSlider.AttachControl(this);

	POINT ptOffset;
	ptOffset.x = Prop_ToolTipOffsetX;
	ptOffset.y = Prop_ToolTipOffsetY;
	m_ToolTip.SetPosition(&ptOffset);
	m_Panel_Thumb.SetToolTip(&m_ToolTip);
}
void CNSlider::OnDestroy()
{
	m_Panel_Thumb.RemoveKeyListener(m_pKeyListener_Slider.m_p);
	this->RemoveMouseListener(m_pMouseListner_Slider);
	m_Panel_Thumb.RemoveMouseListener(m_pMouseListner_Slider_Thumb);
}
CNSlider::eDirection CNSlider::GetDirection()
{
	return m_eDirection;
}
void CNSlider::SetDirection(eDirection eDir)
{
	m_eDirection = eDir;
}
INT64 CNSlider::GetMinValue()
{
	return m_nMin;
}
BOOL CNSlider::SetMinValue(INT64 nMin)
{
	if (m_nMin != nMin)
	{
		m_nMin = nMin;
		this->Update_Logic2Device();
		this->_Fire_OnSliderPropertyChanged(E_SLIDER_PROP_MIN);
		return TRUE;
	}

	return FALSE;
}
INT64 CNSlider::GetMaxValue()
{
	return m_nMax;
}
BOOL CNSlider::SetMaxValue(INT64 nMax)
{
	if (m_nMax != nMax)
	{
		m_nMax = nMax;
		this->Update_Logic2Device();
		this->_Fire_OnSliderPropertyChanged(E_SLIDER_PROP_MAX);
		return TRUE;
	}
	return FALSE;
}
INT64 CNSlider::GetPosValue()
{
	return m_nPos;
}
void CNSlider::SetPosValue(INT64 nPos)
{
	// PM-669 2007/10/17 21:28:58 
	/* {kr}
	nPos  Է° validation check  ,
	nMin, nMax  Ѵ nPos  Է óǾ,
	  Ÿ ׷ rail  UI ׷.
	validation check  ϴ  ߰.
	{/kr} */
	if ( !(nPos >= m_nMin) )
	{
		return;
	}

	if ( !(nPos <= m_nMax) )
	{
		return;
	}

	INT64 nPrevPos = m_nPos;

	if (nPrevPos != nPos)
	{
		m_nPos = nPos;

		this->Update_Logic2Device();
		this->_Fire_OnSliderPropertyChanged(E_SLIDER_PROP_POS);
	}
}
void CNSlider::SetPosValue(INT64 nPos, BOOL bUpdate, BOOL bNotify)
{
	this->SetPosValue(nPos);
}
void CNSlider::AddSliderListener(INSliderListener* pSliderListener)
{
	ATLASSERT(pSliderListener != NULL);
	if(pSliderListener == NULL) return;

	ATLASSERT(m_vSliderListener.Find(pSliderListener) == NULL);
	if(m_vSliderListener.Find(pSliderListener) != NULL) return;

	m_vSliderListener.AddTail(pSliderListener);
}
void CNSlider::RemoveSliderListener(INSliderListener* pSliderListener)
{
	ATLASSERT(pSliderListener);
	POSITION pos = m_vSliderListener.Find(pSliderListener);
	if (pos)
	{
		m_vSliderListener.RemoveAt(pos);		
	}
}
void CNSlider::_Fire_OnSliderPressed()
{
	POSITION pos = m_vSliderListener.GetHeadPosition();
	while (pos)
	{
		INSliderListener* pSliderListener = m_vSliderListener.GetNext(pos);
		if (pSliderListener)
		{
			pSliderListener->OnSliderPressed();
		}
	}

	m_bPressed = TRUE;
}
void CNSlider::_Fire_OnSliderDragging()
{
	POSITION pos = m_vSliderListener.GetHeadPosition();
	while (pos)
	{
		INSliderListener* pSliderListener = m_vSliderListener.GetNext(pos);
		if (pSliderListener)
		{
			pSliderListener->OnSliderDragging();
		}
	}
}
void CNSlider::_Fire_OnSliderReleased(BOOL bCancel)
{
	if (m_bPressed == FALSE) return;

	POSITION pos = m_vSliderListener.GetHeadPosition();
	while (pos)
	{
		INSliderListener* pSliderListener = m_vSliderListener.GetNext(pos);
		if (pSliderListener)
		{
			pSliderListener->OnSliderReleased(bCancel);
		}
	}

	m_bPressed = FALSE;
}
void CNSlider::_Fire_OnSliderPropertyChanged(eProperty eProp)
{
	POSITION pos = m_vSliderListener.GetHeadPosition();
	while (pos)
	{
		INSliderListener* pSliderListener = m_vSliderListener.GetNext(pos);
		if (pSliderListener)
		{
			pSliderListener->OnSliderPropertyChanged(eProp);
		}
	}

}
void CNSlider::DrawComponent(HDC hDC)
{
	INSliderUI* pSliderUI = reinterpret_cast<INSliderUI*>(m_pComponentUI);
	ATLASSERT(IS_KIND_OF(INSliderUI, pSliderUI) == TRUE);

	CStateControl::eControlState eSliderState = m_StatePanelSlider.GetState();
	CStateControl::eControlState eThumbState = m_StatePanelThumb.GetState();

	CRect rcSlider;
	this->GetClientRect(&rcSlider);

	CRect rcThumb;
	m_Panel_Thumb.GetBounds(&rcThumb);

	if(m_Panel_Thumb.IsVisible() == FALSE)
	{
		rcThumb.SetRectEmpty();
	}

	pSliderUI->DrawSlider(hDC, &rcSlider, &rcThumb, eSliderState, eThumbState);	
}
void CNSlider::SetToolTipText(LPCTSTR szToolTipText)
{
	// {kr} ؽƮ . {/kr}
	m_ToolTip.SetText(szToolTipText);
}
void CNSlider::SetRailRect(LPRECT prcRail)
{
	m_rcRail.CopyRect(prcRail);
}
void CNSlider::GetRailRect(LPRECT prcRail)
{
	::CopyRect(prcRail, &m_rcRail);
}
void CNSlider::SetThumbStartRect(LPRECT prcThumbStart)
{
	m_rcThumbStart.CopyRect(prcThumbStart);
	// 2007/10/10 21:00:14 
	/* {kr}
		̴  RECT Ҷ presentation ʱȭ Ǵ  ߸.
		m_Panel_Thumb.MoveWindow(&m_rcThumbStart, TRUE);
	{kr} */
	//m_Panel_Thumb.MoveWindow(&m_rcThumbStart, TRUE);
}
void CNSlider::GetThumbStartRect(LPRECT prcThumbStart)
{
	::CopyRect(prcThumbStart, &m_rcThumbStart);
}
void CNSlider::SetThumbEndRect(LPRECT prcThumbEnd)
{
	m_rcThumbEnd.CopyRect(prcThumbEnd);
}
void CNSlider::GetThumbEndRect(LPRECT prcThumbEnd)
{
	::CopyRect(prcThumbEnd, &m_rcThumbEnd);
}
void CNSlider::OnMouseLeave()
{
	__super::OnMouseLeave();
	m_ToolTip.SetVisible(FALSE);
}
void CNSlider::LayoutContainer(CContainer* pContainer)
{
	this->Update_Logic2Device();
}
void CNSlider::SetUI(IComponentUI* pComponentUI)
{
	ATLASSERT(IS_KIND_OF(INSliderUI, pComponentUI) == TRUE);
	m_pComponentUI = pComponentUI;
}
void CNSlider::Update_Logic2Device()
{
	// PM-556 2007/10/05 17:07:30 
	if ( !(m_nMax >= m_nPos) ) return;
	if ( !(m_nPos >= m_nMin) ) return;
	if ( !(m_nMax > m_nMin) ) return;

	CRect rcRail(&m_rcRail);
	CRect rcThumbStart(&m_rcThumbStart);
	CRect rcThumbEnd(&m_rcThumbEnd);
	CRect rcThumbCurrent(&rcThumbStart);
	
	if(m_eDirection == E_SLIDER_DIRECTION_HORZ)
	{
		int nXMove = rcThumbStart.left + (rcThumbEnd.left - rcThumbStart.left) * (m_nPos - m_nMin) / max(1, (m_nMax - m_nMin));
		rcThumbCurrent.MoveToX(nXMove);
	}
	else if (m_eDirection == E_SLIDER_DIRECTION_VERT)
	{
		int nYMove = rcThumbStart.top + (rcThumbEnd.top - rcThumbStart.top) * (m_nPos - m_nMin) / max(1, (m_nMax - m_nMin));
		rcThumbCurrent.MoveToY(nYMove);
	}

	m_Panel_Thumb.MoveWindow(&rcThumbCurrent);
	this->Invalidate();
}
void CNSlider::Update_Device2Logic(BOOL bNotify /*= TRUE*/)
{
	CRect rcRail(&m_rcRail);
	CRect rcThumbStart(&m_rcThumbStart);
	CRect rcThumbEnd(&m_rcThumbEnd);
	CRect rcThumb;
	m_Panel_Thumb.GetBounds(&rcThumb);

	INT64 nPos = 0;
	if(m_eDirection == E_SLIDER_DIRECTION_HORZ)
	{
		ATLASSERT(rcThumbEnd.left != rcThumbStart.left);
		nPos = m_nMin + (m_nMax - m_nMin) * (rcThumb.left - rcThumbStart.left) / max(1, rcThumbEnd.left - rcThumbStart.left);
	}
	else if (m_eDirection == E_SLIDER_DIRECTION_VERT)
	{
		ATLASSERT(rcThumbEnd.top != rcThumbStart.top);
		nPos = m_nMin + (m_nMax - m_nMin) * (rcThumbStart.top - rcThumb.top) / max(1, rcThumbStart.top - rcThumbEnd.top);
	}

	this->SetPosValue(nPos, FALSE, bNotify);
}
BOOL CNSlider::EnableWindow( BOOL bEnabled )
{
	BOOL bResult = __super::EnableWindow(bEnabled);
	m_Panel_Thumb.SetVisible(bEnabled);
	return bResult;
}
IMPLEMENT_MESSAGE_HANDLER(CNSlider, OnNcActivate)
{
	if (wParam == FALSE)
	{
		if(m_ToolTip.IsVisible() == TRUE)	
		{
			m_ToolTip.SetVisible(FALSE);
		}

		m_Panel_Thumb.ReleaseCapture();
		this->_Fire_OnSliderReleased(TRUE);
		this->Invalidate();
	}

	bHandled = FALSE;
	return 0;
}
void CNSlider::SetKeyHop( INT64 nKeyHop )
{
	ATLASSERT(nKeyHop >= 0); //hhdatlassert
	if ( !(nKeyHop >= 0) ) return;

	m_nKeyHop = nKeyHop;
}
INT64 CNSlider::GetKeyHop()
{
	return m_nKeyHop;
}
void CNSlider::SetKeyPressedTimePeriod( int nKeyPressedTimePeriod )
{
	ATLASSERT(nKeyPressedTimePeriod >= 0); //hhdatlassert
	if ( !(nKeyPressedTimePeriod >= 0) ) return;

	m_nKeyPressedTimePeriod = nKeyPressedTimePeriod;
}
int CNSlider::GetKeyPressedTimePeriod()
{
	return m_nKeyPressedTimePeriod;
}
CNToolTip* CNSlider::GetToolTip()
{
	return &m_ToolTip;
}

CNSliderThumb* CNSlider::GetThumb()
{
	return &m_Panel_Thumb;
}
//////////////////////////////////////////////////////////////////////////
CMouseListener_Slider::CMouseListener_Slider(
	CNSlider* pSlider,
	CMouseListener_Slider_Thumb* pMouseListener_Slider_Thumb)
{
	ATLASSERT(IS_KIND_OF(CNSlider, pSlider) == TRUE);
	if(IS_KIND_OF(CNSlider, pSlider) == FALSE) return;

	if(pMouseListener_Slider_Thumb == NULL) return;

	m_pSlider = pSlider;
	m_pMouseListener_Slider_Thumb = pMouseListener_Slider_Thumb;
}
void CMouseListener_Slider::OnMousePressed(CMouseEvent* pMouseEvent)
{
	if(pMouseEvent->m_nMouseButton == CMouseEvent::E_MOUSE_BUTTON_LEFT)
	{
		m_ptPressed = pMouseEvent->m_Point;

		CRect rcRail(&(m_pSlider->m_rcRail));
		CRect rcThumbStart(&(m_pSlider->m_rcThumbStart));
		CRect rcThumbEnd(&(m_pSlider->m_rcThumbEnd));

		CRect rcThumb(&rcThumbStart);

		if(rcRail.PtInRect(pMouseEvent->m_Point) == TRUE)
		{
			if(m_pSlider->m_eDirection == CNSlider::E_SLIDER_DIRECTION_HORZ)
			{
				rcThumb.MoveToX(pMouseEvent->m_Point.x - rcThumb.Width() / 2);
				if(rcThumb.left < rcThumbStart.left)
				{
					rcThumb.CopyRect(&rcThumbStart);
				}
				else if(rcThumb.right > rcThumbEnd.right)
				{
					rcThumb.CopyRect(&rcThumbEnd);
				}
			}
			else
			{
				rcThumb.MoveToY(pMouseEvent->m_Point.y - rcThumb.Height() / 2);
				if(rcThumb.top < rcThumbEnd.top)
				{
					rcThumb.CopyRect(&rcThumbEnd);
				}
				else if(rcThumb.top > rcThumbStart.top)
				{
					rcThumb.CopyRect(&rcThumbStart);
				}
			}
			
			// {kr}  ŭ  ̵ְ {/kr}
			m_pSlider->m_Panel_Thumb.MoveWindow(&rcThumb, TRUE);
			
			// {kr}  ߰  {/kr}
			rcThumb.MoveToXY(0, 0);
			POINT ptThumbMid = rcThumb.CenterPoint();
			// {kr}  ߰ ٵ 콺 ʿ . {/kr}
			m_pMouseListener_Slider_Thumb->DoPressed(&ptThumbMid);
			
			// {kr}  ǥȯ : ̽--> {/kr}
			m_pSlider->Update_Device2Logic(TRUE);

			// {kr} ̴ ٷ ٽñ׸ . {/kr}
			m_pSlider->InvalidateImmediately();
		}
	}
}
void CMouseListener_Slider::OnMouseReleased(CMouseEvent* pMouseEvent)
{
	if(pMouseEvent->m_nMouseButton == CMouseEvent::E_MOUSE_BUTTON_LEFT)
	{
		CRect rcRail(&(m_pSlider->m_rcRail));
		m_pSlider->_Fire_OnSliderReleased(FALSE);
		m_pSlider->Invalidate();
	}

}
void CMouseListener_Slider::OnMouseEntered(CMouseEvent* pMouseEvent)
{
	m_pSlider->InvalidateRect(NULL);
}
void CMouseListener_Slider::OnMouseExited(CMouseEvent* pMouseEvent)
{
	m_pSlider->InvalidateRect(NULL);
}
//////////////////////////////////////////////////////////////////////////	
CMouseListener_Slider_Thumb::CMouseListener_Slider_Thumb(CNSlider* pSlider, CNPanel* pThumb)
{
	ATLASSERT(IS_KIND_OF(CNSlider, pSlider) == TRUE);
	m_pSlider = pSlider;

	ATLASSERT(IS_KIND_OF(CNPanel, pThumb) == TRUE);
	m_pThumb = pThumb;

	m_pSlider->m_ToolTip.SetOwner(pThumb);
	::ZeroMemory(&m_ptOld, sizeof(POINT));
	m_bEnter = FALSE;
}
void CMouseListener_Slider_Thumb::OnMousePressed(CMouseEvent* pMouseEvent)
{
	if(pMouseEvent->m_nMouseButton == CMouseEvent::E_MOUSE_BUTTON_LEFT)
	{
		this->DoPressed(&(pMouseEvent->m_Point));
	}
}
void CMouseListener_Slider_Thumb::OnMouseReleased(CMouseEvent* pMouseEvent)
{
	if(pMouseEvent->m_nMouseButton == CMouseEvent::E_MOUSE_BUTTON_LEFT)
	{
		this->DoReleased(&(pMouseEvent->m_Point));
	}
}
void CMouseListener_Slider_Thumb::OnMouseEntered(CMouseEvent* pMouseEvent)
{
	CRootContainer* pRootContainer = m_pSlider->GetRootContainer();
	ATLASSERT(pRootContainer != NULL);

	POINT ptOffset;
	ptOffset.x = CNSlider::Prop_ToolTipOffsetX;
	ptOffset.y = CNSlider::Prop_ToolTipOffsetY;
	m_pSlider->m_ToolTip.SetPosition(&ptOffset);
	
	// {kr} 콺Ͱ  ö󰡸  Ÿ. {/kr}
	m_pSlider->m_ToolTip.SetVisible(TRUE);
}
void CMouseListener_Slider_Thumb::OnMouseExited(CMouseEvent* pMouseEvent)
{
	// {kr} 콺Ͱ     . {/kr}
	m_pSlider->m_ToolTip.SetVisible(FALSE);
}
void CMouseListener_Slider_Thumb::OnMouseMoved(CMouseEvent* pMouseEvent)
{
	// PM-677 2007/10/17 21:06:20 
	/* {kr}
		m_pSlider->GetClientRect(&rcThumb); 
		pThumb->GetClientRect(&rcThumb);  ٲ.
		 bound ؾ ϴµ slider bound ߱   ߻.
		 mistype   .
	{/kr} */
	CRect rcThumb;
	CComponent* pThumb = pMouseEvent->m_pEventSource;
	pThumb->GetClientRect(&rcThumb);
	
	CRootContainer* pRootContainer = m_pSlider->GetRootContainer();
	ATLASSERT(pRootContainer != NULL);

	// {kr} ̴ 콺 pressed ǥ Ǿ    ¿ ٷ . {/kr}
	if (m_ptOld.x == 0 &&
		m_ptOld.y == 0) return;

	if (m_pThumb == pRootContainer->GetCapturedComponent())
	{
		CRect rcThumb;
		m_pThumb->GetBounds(&rcThumb);

		CRect rcSlider;
		m_pSlider->GetClientRect(&rcSlider);

		CRect rcRail(&(m_pSlider->m_rcRail));
		CRect rcThumbStart(&(m_pSlider->m_rcThumbStart));
		CRect rcThumbEnd(&(m_pSlider->m_rcThumbEnd));

		if(m_pSlider->m_eDirection == CNSlider::E_SLIDER_DIRECTION_HORZ)
		{
			int nXMove = pMouseEvent->m_Point.x - m_ptOld.x;

			rcThumb.OffsetRect(nXMove, 0);

			if(rcThumb.left < rcThumbStart.left)
			{
				rcThumb.CopyRect(&rcThumbStart);
			}

			if(rcThumb.right > rcThumbEnd.right)
			{
				rcThumb.CopyRect(&rcThumbEnd);
			}
		}
		else if(m_pSlider->m_eDirection == CNSlider::E_SLIDER_DIRECTION_VERT)
		{
			int nYMove = m_ptOld.y - pMouseEvent->m_Point.y;

			rcThumb.OffsetRect(0, -nYMove);

			if(rcThumb.bottom > rcThumbStart.bottom)
			{
				rcThumb.CopyRect(&rcThumbStart);
			}

			if(rcThumb.top < rcThumbEnd.top)
			{
				rcThumb.CopyRect(&rcThumbEnd);
			}
		}

		m_pThumb->MoveWindow(&rcThumb);
		m_pSlider->Update_Device2Logic(FALSE);
		m_pSlider->_Fire_OnSliderDragging();
		m_pSlider->Invalidate();
	}

	// {kr}  콺 ö󰡰 {/kr}
	// {kr} exit ¿  {/kr}
	if (m_pThumb->IsMouseOver() == TRUE &&
		m_bEnter == FALSE)
	{
		// {kr}  show {/kr}
		m_pSlider->GetToolTip()->SetVisible(TRUE);
		m_bEnter = TRUE;
	}
	// {kr}  콺  {/kr}
	else if (m_pThumb->IsMouseOver() == FALSE )
	{
		// {kr}  hide {/kr}
		m_pSlider->GetToolTip()->SetVisible(FALSE);
		m_bEnter = FALSE;
	}
}
void CMouseListener_Slider_Thumb::DoPressed( LPPOINT pptPressed )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(pptPressed != NULL);
	if(!(pptPressed != NULL)) return;

	// {kr} ̴, ̴ NULL üũ. {/kr}
	ATLASSERT(m_pThumb != NULL);
	if(!(m_pThumb != NULL)) return;
	ATLASSERT(m_pSlider != NULL);
	if(!(m_pSlider != NULL)) return;

	// {kr} ̴  ĸ. {/kr}
	// {kr} DoReleased Լ ̴  ĸ. {/kr}
	// {kr}  . {/kr}
	m_pThumb->SetCapture();
	// {kr} ̴ 濡 Ŀ . {/kr}
	m_pThumb->SetFocus();
	// {kr}   Ʈ . {/kr}
	m_ptOld = *pptPressed;
	// {kr}  ̴   . {/kr}
	m_pThumb->GetBounds(&m_rcBoundPressed);
	// {kr} ̴ listeners ̴  ˸. {/kr}
	m_pSlider->_Fire_OnSliderPressed();
}
void CMouseListener_Slider_Thumb::DoReleased( LPPOINT pptReleased )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(pptReleased != NULL);
	if(!(pptReleased != NULL)) return;

	// {kr} ̴, ̴ NULL üũ. {/kr}
	ATLASSERT(m_pThumb != NULL);
	if(!(m_pThumb != NULL)) return;
	ATLASSERT(m_pSlider != NULL);
	if(!(m_pSlider != NULL)) return;

	// {kr} ̴  ĸ . {/kr}
	m_pThumb->ReleaseCapture();

	// {kr}   Ʈ . {/kr}
	m_ptOld = *pptReleased;

	// {kr} ̴    . {/kr}
	CRect rcBoundThumb;
	m_pThumb->GetBounds(&rcBoundThumb);
	
	// {kr} ̴  ̽   {/kr}
	BOOL bChangedThumbPos = (rcBoundThumb != m_rcBoundPressed);
	if (bChangedThumbPos)
	{
		// {kr} ̽-->  ȯ. {/kr}
		m_pSlider->Update_Device2Logic(TRUE);
	}

	//hhdadd 2008/03/28
	// {kr} ̴-mouse-released     ־. {/kr}
	// {kr}     visible-true, visible-false   . {/kr}
	// {kr} ׷ PM-1105    Ǿ . {/kr}
	//// {kr} ̴  ߱. {/kr}
	//m_pSlider->m_ToolTip.SetVisible(FALSE);

	// {kr} ̴ listeners ̴  ˸. {/kr}
	m_pSlider->_Fire_OnSliderReleased(FALSE);
}
//////////////////////////////////////////////////////////////////////////
IMPLEMENT_RTTI(INSliderUI, IComponentUI)
//////////////////////////////////////////////////////////////////////////
CKeyListener_Slider::CKeyListener_Slider( CNSlider* pSlider )
{
	ATLASSERT(IS_KIND_OF(CNSlider, pSlider) == TRUE); //hhdatlassert
	if ( !(IS_KIND_OF(CNSlider, pSlider) == TRUE) ) return;

	m_pSlider = pSlider;
}
CKeyListener_Slider::~CKeyListener_Slider()
{

}
void CKeyListener_Slider::OnKeyPressed( CKeyEvent* pKeyEvent )
{
	static DWORD dwTickCount = 0;
	//int nKeyPressedTimePeriod = m_pSlider->GetKeyPressedTimePeriod();
	int nKeyPressedTimePeriod = 0;

	if (::GetTickCount() - dwTickCount > nKeyPressedTimePeriod)
	{
		INT64 nKeyHop = m_pSlider->GetKeyHop();
		
		if(	pKeyEvent->m_nChar == VK_LEFT || 
			pKeyEvent->m_nChar == VK_DOWN || 
			pKeyEvent->m_nChar == VK_SUBTRACT)
		{
			INT64 nPos = m_pSlider->GetPosValue();
			m_pSlider->SetPosValue
				(
				max(m_pSlider->GetMinValue(), nPos - nKeyHop)
				);
		}
		else if(pKeyEvent->m_nChar == VK_RIGHT ||
				pKeyEvent->m_nChar == VK_UP ||
				pKeyEvent->m_nChar == VK_ADD )
		{
			INT64 nPos = m_pSlider->GetPosValue();
			
			m_pSlider->SetPosValue
				(
				min(m_pSlider->GetMaxValue(), nPos + nKeyHop)
				);
		}
		dwTickCount = ::GetTickCount();
	}
}
void CKeyListener_Slider::OnKeyReleased( CKeyEvent* pKeyEvent )
{
}